#from rdradcp import rdradcp
from readRawBinADCP import readRawBinADCP
from plot_ADCP_velocity import plot_ADCP_velocity
from plot_ADCP_vel_FFT import plot_depth_averaged_analysis

import Timer
import csv

print  '--> Default read 2011 data File:2011_west_gap_DPLWG000.000) \n'
print '\n\n'


def write_datefile(writer, velocity):
    idx = 0
    numdat = []
    prev = 0
    prevtxt = ''
    bins = velocity.shape[0]
    for i in range(0, velocity.shape[1]):
        #for j in range(0, bins)\

        writer.writerow(velocity[:, i])

    print "Done writing file"

def writeBins(data, path_out, fname):
    path_out = "/software"
    ofile = open(path_out + '/' + fname, "wb")
    writer = csv.writer(ofile, delimiter = ',', quotechar = '"', quoting = csv.QUOTE_MINIMAL)
    write_datefile(writer, data)
    ofile.close()


try:
    with Timer.Timer() as t:
        #[adcp, cfg, ens, hdr] = readRawBinADCP('/software/scientific/Matlab_files/RDADCP/TRCA/2011/2011_west_gap_DPLWG000.000', 1, [100, 7726], 'info', 'yes', 'baseyear', 2000, 'despike', 'yes');
        #[adcp, cfg, ens, hdr] = readRawBinADCP('/home/bogdan/Download/DPL3_000.000', 1, [1, 1387893], 'info', 'yes', 'baseyear', 2000, 'despike', 'yes')
        [adcp, cfg, ens, hdr] = readRawBinADCP('/home/bogdan/Download/DPL3_000.000', 1, [1, 1100000], 'info', 'yes', 'baseyear', 2000, 'despike', 'yes')
        #[adcp, cfg, ens, hdr] = readRawBinADCP('/software/scientific/DPL1_000.000', 1, [1, 6938], 'info', 'yes', 'baseyear', 2000, 'despike', 'yes')
finally:
    print('Read took %.03f sec.' % t.interval)

print 'ADCP configuration'
print '----------------------'
print 'no of bins :%d' % adcp.config.n_cells
print 'first bin distance :%f' % adcp.config.bin1_dist
print 'no of beams :%d' % adcp.config.n_beams
print 'system of coordinates :%s' % adcp.config.coord_sys
print 'time between pings :%f' % adcp.config.time_between_ping_groups
print 'no of pings per ensamble :%d' % adcp.config.pings_per_ensemble
# IMPORTANT to know for depth bin calculations adcp.config.ranges
print '----------------------'

path_out = "/software/SAGEwork/rdradcp"

ylabel = 'East velocity [m/s]';
data_args1 = [adcp.east_vel, ylabel]
#plot_ADCP_velocity(adcp, data_args1, 'Lake Opeongo - East velocity profiles')
writeBins(adcp.east_vel, path_out, "eastVel.csv")

data_args2 = [adcp.north_vel, 'North Velocity']
#plot_ADCP_velocity(adcp, data_args2, 'Lake Opeongo - North velocity profiles')
writeBins(adcp.north_vel, path_out, "northVel.csv")

data_args3 = [adcp.vert_vel, 'Vertical Velocity']
#plot_ADCP_velocity(adcp, data_args3, 'Lake Opeongo - Vertical velocity profiles')
writeBins(adcp.vert_vel, path_out, "vertVel.csv")

data_args4 = [adcp.error_vel , 'Error Velocity']
#plot_ADCP_velocity(adcp, data_args4, 'Lake Opeongo - Error velocity profiles')
writeBins(adcp.error_vel, path_out, "errorVel.csv")


data = adcp.east_vel
ylabel = 'East velocity Singles side amplitude spectrum [m/s]';
data_args1 = [data, ylabel]
#plot_depth_averaged_analysis(adcp, data_args1, 'Toronto Harbour West gap - East velocity frequencies Spectrum')
