import numpy
import matplotlib.pyplot as plt
from datetime import datetime
from matplotlib.dates import date2num, num2date
from matplotlib.dates import MONDAY, SATURDAY
from pylab import meshgrid
import matplotlib.dates
from matplotlib.colors import LogNorm
import time
import math
from scipy import fftpack
import readRawBinADCP

debug = False
def nextpow2(i):
    """
    Find the next power of two

    >>> nextpow2(5)
    8
    >>> nextpow2(250)
    256
    """
    # do not use numpy here, math is much faster for single values
    buf = math.ceil(math.log(i) / math.log(2))
    return int(math.pow(2, buf))

'''
def nextpow2(i):
    """
    Find 2^n that is equal to or greater than.
    """
    n = 2
    while n < i: n = n * 2
    return n
'''

def plot_depth_averaged_analysis(adcp, data_args, graph_title, subplot = False) :
    '''UNTITLED Summary of this function goes here
      Detailed explanation goes here
    '''
    print '--> Depth averaged east velocity analysis'
    east_vel, ylabel = data_args
    L = numpy.size(adcp.number[0]) - 1

    averaged_east_vel = readRawBinADCP.nmean(east_vel, 0)
    #averaged_east_vel = east_vel[9]

    t = adcp.mtime[0][0:L]
    averaged_east_vel = averaged_east_vel[0:L]

    #prepare for the amplitude spectrum analysis
    dt_s = (t[2] - t[1]) * 86400 # Sampling period [s]
    Fs = 1 / (dt_s)           # Samplig freq    [Hz]


    NFFT = nextpow2(L)

    Y = fftpack.fft(averaged_east_vel, NFFT)

    NumUniquePts = int(math.ceil((NFFT + 1) / 2))

    fftx = Y[0:NumUniquePts - 1]
    mx = 2 * abs(fftx.real) / NumUniquePts

    #This is an evenly spaced frequency vector with NumUniquePts points.
    # generate a freq spectrum from 0 to Fs/2 (Nyquist freq) , NFFT/2+1 points

    f = numpy.array(range(0, NumUniquePts - 1))
    f = f * Fs / NFFT

    freq = numpy.fft.fftfreq(NFFT)
    tph = 1 / f / 3600

    plt.plot(tph, mx)
    plt.ylabel(ylabel)
    plt.xlabel("Period (h)")
    plt.show()
#end




